#
#
#
#

use strict;

my $doctaur_prefix_dir=$ARGV[0];
$doctaur_prefix_dir=~s/\/\s*$//;
my $cnffile=$doctaur_prefix_dir.'/htdig/conf/htdig.conf';
my $indxfile=$doctaur_prefix_dir.'/index.html';
my $dctrcnffile=$doctaur_prefix_dir.'/conf/doctaur.conf';
my $docsjsfile=$doctaur_prefix_dir.'/doctaur_docs.js'; 

my $doctaur_url_complet=$ARGV[1];
$doctaur_url_complet=~s/\/\s*$//; 
my $doctaur_url_dir=$doctaur_url_complet;
$doctaur_url_dir=~s/^[^\/]*\/\///;
$doctaur_url_dir=~s/^[^\/]*//;

my $doctaur_prefix_cgi_dir=$ARGV[2];
$doctaur_prefix_cgi_dir=~s/\/\s*$//; 
my @pl_files = (
	$doctaur_prefix_cgi_dir.'/doctaur.pl', 
	$doctaur_prefix_cgi_dir.'/intranet_version.pl', 
	$doctaur_prefix_cgi_dir.'/request.pl',
	$doctaur_prefix_cgi_dir.'/settings_help.pl', 
	$doctaur_prefix_cgi_dir.'/search_help.pl',
	$doctaur_prefix_cgi_dir.'/support.pl', 
	$doctaur_prefix_cgi_dir.'/messages.pl',
	$doctaur_prefix_cgi_dir.'/send.pl', 
	$doctaur_prefix_cgi_dir.'/login.pl',
	$doctaur_prefix_cgi_dir.'/tools.pl', 
	$doctaur_prefix_cgi_dir.'/settings_proccess.pl',
        $doctaur_prefix_cgi_dir.'/entrance.pl', 
	$doctaur_prefix_cgi_dir.'/settings.pl',
        $doctaur_prefix_cgi_dir.'/inserter.pl',
        $doctaur_prefix_cgi_dir.'/installation_help.pl',
        $doctaur_prefix_cgi_dir.'/archive_expansion_help.pl',
        $doctaur_prefix_cgi_dir.'/release_notes.pl',
        $doctaur_prefix_cgi_dir.'/logoff.pl'
);


my $doctaur_url_cgi_complet=$ARGV[3]; 
$doctaur_url_cgi_complet=~s/\/\s*$//;
my $doctaur_url_cgi_dir=$doctaur_url_cgi_complet;
$doctaur_url_cgi_dir=~s/^[^\/]*\/\///;
$doctaur_url_cgi_dir=~s/^[^\/]*\//\//;

my $perl_dir=$ARGV[4];

open (F, "$cnffile");
my @lines=<F>;
close F;

open (F, ">$cnffile"); 
foreach my $line (@lines)
{
  $line =~ s/doctaur_prefix_dir/$doctaur_prefix_dir/;
  $line =~ s/doctaur_url_dir/$doctaur_url_dir/; 
  $line =~ s/doctaur_url_complet/$doctaur_url_complet/;

  $line =~ s/doctaur_prefix_cgi_dir/$doctaur_prefix_cgi_dir/;
  $line =~ s/doctaur_url_cgi_dir/$doctaur_url_cgi_dir/;
  $line =~ s/doctaur_url_cgi_complet/$doctaur_url_cgi_complet/;

  print F $line;
}

close F;



open (F, "$indxfile");
@lines=<F>;
close F;
 
open (F, ">$indxfile");
foreach my $line (@lines)
{
  $line =~ s/doctaur_url_cgi_complet/$doctaur_url_cgi_complet/;
  print F $line;
}
 
close F;



open (F, "$dctrcnffile");
@lines=<F>;
close F;
 
open (F, ">$dctrcnffile");
foreach my $line (@lines)
{
  $line =~ s/doctaur_prefix_dir/$doctaur_prefix_dir/;
  $line =~ s/doctaur_url_dir/$doctaur_url_dir/;
  $line =~ s/doctaur_url_complet/$doctaur_url_complet/;
 
  $line =~ s/doctaur_prefix_cgi_dir/$doctaur_prefix_cgi_dir/;
  $line =~ s/doctaur_url_cgi_dir/$doctaur_url_cgi_dir/;
  $line =~ s/doctaur_url_cgi_complet/$doctaur_url_cgi_complet/;

  print F $line;
}
 
close F;


open (F, "$docsjsfile");
@lines=<F>;
close F;
 
open (F, ">$docsjsfile");
foreach my $line (@lines)
{
  $line =~ s/doctaur_prefix_dir/$doctaur_prefix_dir/;
  $line =~ s/doctaur_url_dir/$doctaur_url_dir/;
  $line =~ s/doctaur_url_complet/$doctaur_url_complet/;
 
  $line =~ s/doctaur_prefix_cgi_dir/$doctaur_prefix_cgi_dir/;
  $line =~ s/doctaur_url_cgi_dir/$doctaur_url_cgi_dir/;
  $line =~ s/doctaur_url_cgi_complet/$doctaur_url_cgi_complet/;
 
  print F $line;
}
close F;


foreach my $pl_file (@pl_files)
{

    open (F, "$pl_file");
    my @lines=<F>;
    close F;
     
    open (F, ">$pl_file");
    foreach my $line (@lines)
    {
      $line =~ s/\/usr\/bin\/perl/$perl_dir/;
      print F $line;
    }

    
}

open(F, 'install.log');
my @content = <F>;
close F;
my $compil_error = '';

foreach my $line (@content)
{
    if ($line=~/error:/i){$compil_error.=$line."\n";}
}

print $compil_error."\n";

print qq
!
Now I'm creating search databases, be patient.
!;

system ("$doctaur_prefix_dir/htdig/bin/rundig>>install.log 2>>install.log");

my @db_stat = stat("$doctaur_prefix_dir/htdig/db/db.wordlist");
my $db_stat = $db_stat[7];


if ($compil_error || $db_stat<5000000)
{
	if ($compil_error)
	{
		print qq!
Compilation error:
$compil_error
You can find more details in install.log. 
!;
	}
	elsif ($db_stat<5000000)
	{
		print qq!
Error:
It looks that DB for searching was not succesful created. 
Probably cause: your webserver is bad configured for DocTaur or you have less than 100MB of free disk space.

Be sure that you have properly configured your web server.
directories:
        $doctaur_prefix_dir
        $doctaur_prefix_cgi_dir
should be accessible by URLs:
        $doctaur_url_complet
        $doctaur_url_cgi_complet
and it should be possible to execute cgi scripts in directory:
        $doctaur_prefix_cgi_dir
Try URL: $doctaur_url_complet and when it will be correct run $doctaur_prefix_dir/htdig/bin/rundig from command line. This command will create DB again.
!;
	}
}
else
{
    print qq!

Everything done and looks OK.

Now you can log to administrator's part of site using login name "admin" and empty password.
Don't forget to set admin password on the administrator's settings page.

See
$doctaur_url_cgi_complet/archive_expansion_help.pl to update documentations archive.

Don't forget to add the back links to all documentations. It helps you with navigation. You can do it on the administrator's tools page.

!;
}

